<?php
/**
 * Created by PhpStorm.
 * User: carinaoliveira
 * Date: 01/07/14
 * Time: 11:50
 */

namespace Fiscal\Logic\CalculoReceitaBruta;

use Indeterminado\Entities\Receitabruta;


class Ano {

    public static function existeAno($ano, $cdsimplesnac, $cdempresa) {

        try {
            $sucesso = false;

            $where = "    TO_CHAR(TO_DATE(DTREFRECEITABR), 'YYYY') = ?
                      AND CDSIMPLESNACIONAL = ?
                      AND CDEMPRESA = ?";

            $params = array($ano, $cdsimplesnac, $cdempresa);

            $anos = Receitabruta::getObjectsByWhere($where, $params);

            if(count($anos) > 0) {
                $sucesso = true;
            }
            else {
                $sucesso = false;
            }

        }
        catch (\Exception $e) {
            throw $e;
            $db->rollback();
        }

        return $sucesso;

    }

    public static function insereAnoERecMen($campos) {

        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = \Setforms2\Shared\Registry::getEntityManager();

        $sucesso = false;

        try {
            $recmen = new Receitabruta();

            $recmen->setCdempresa($campos['CDEMPRESA']);
            $recmen->setCdsimplesnacional($campos['CDSIMPLESNACIONAL']);
            $recmen->setDtrefreceitabr($campos['DTREFRECEITABR']);
            $recmen->setVrsaldocompoe($campos['VRSALDOCOMPOE']);
            $recmen->setVrsaldodeduz($campos['VRSALDODEDUZ']);
            $recmen->setVrreceitabr($campos['VRRECEITABR']);
            $recmen->setVrsaldonegmes($campos['VRSALDONEGMES']);
            $recmen->setIdstatusmes($campos['IDSTATUSMES']);
            $recmen->setIdinfmanual($campos['IDINFMANUAL']);
            $recmen->setNrorg($campos['NRORG']);
            $recmen->setIdativo($campos['IDATIVO']);
            $recmen->setCdoperinclusao($campos['CDOPERINCLUSAO']);
            $recmen->setDtultatu($campos['DTULTATU']);
            $recmen->setDtinclusao($campos['DTINCLUSAO']);
            $recmen->setNrorgultatu($campos['NRORGULTATU']);
            $recmen->setCdoperultatu($campos['CDOPERULTATU']);
            $recmen->setNrorginclusao($campos['NRORGINCLUSAO']);

            $recmen->persist();

            $connection->flush();
            $db->commit();

            $sucesso = true;

        } catch (\Exception $e) {
            $db->rollback();
        }

        return $sucesso;
    }

    public static function deletaAnoERecMen($ano) {

        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        $message = tk_get_message_by_name('msg_ExclusaoRealizada');

        try {

            $where = "TO_CHAR(TO_DATE(DTREFRECEITABR), 'YYYY') = ?";

            $params = array($ano);

            $recmens = Receitabruta::getObjectsByWhere($where, $params);

            foreach($recmens as $recmen) {

                $recmen->delete(); //deleta receitas mensais

            }

            $connection->flush();
            $db->commit();

            tk_reload_data_with_filter('tab_pbi00087_000_004');
            tk_reload_data_with_filter('tab_pbi00087_000_003');
            tk_message($message, 'success');

        } catch (\Exception $e) {
            $message = tk_get_message_by_name('msg_ExclusaoImpossibilitada');
            tk_message($message, 'warning');
            $db->rollback();
        }

    }

} 